/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef INFO_H
#define INFO_H

#include <QtGui>



class Info:public QObject
{
    Q_OBJECT
    private:
     QWidget *parent;
     QString appname;
     QList<QLabel*>labelList;
     QStringList messageString;
     static QString* _dataPath;

    public slots:
     void websiteVisit();
     void about();
     void aboutQt();

    public:
     Info(QWidget *wdg,QString name);
     ~Info();

     enum Message{PrinterNotFound,PrinterError,PrintAreaError,ImageSaveError,SchemeSaveError};

     void setParent(QWidget *wdg){parent=wdg;}
     void setAppname(const QString &name){appname=name;}

     void messageSplash(QString msgstr,int delay=4000);
     void messageSplash(Message msgid,int delay=4000);


     void message(QString msgstr)const{message(parent,appname,msgstr);}

     static void message(QWidget *parent,QString namestr,QString msgstr){QMessageBox::information(parent,namestr,msgstr);}
     static QString colorSign(int i);
     static void setDataPath(const QString &path){if(!_dataPath)_dataPath=new QString(path);}
     static QString dataPath(){return *_dataPath;}
     static QString imageFilter(const QList<QByteArray>& baList);

};

#endif
